--4v4 Pop-a-Balloon Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 12
local team2Score = 12
local giveSpells = {M_SPELL_BLAST,M_SPELL_INSECT_PLAGUE,M_SPELL_LIGHTNING_BOLT,M_SPELL_WHIRLWIND,M_SPELL_GHOST_ARMY}
local pupTimer = 12*50+ 12*math.random(10,20)

local b1,b2,b3,b4,b5,b6 = 4,4,4,4,4,4
----------------------------------------------------spell constants
sti = spells_type_info()

local balloonPopper = M_SPELL_INSECT_PLAGUE
sti[balloonPopper].Cost = 800000
sti[balloonPopper].OneOffMaximum = 1
sti[balloonPopper].WorldCoordRange = 1024
sti[balloonPopper].CursorSpriteNum = 100
sti[balloonPopper].ToolTipStrIdx = sti[M_SPELL_BLOODLUST].ToolTipStrIdx
sti[balloonPopper].ToolTipStrIdxLSME = sti[M_SPELL_BLOODLUST].ToolTipStrIdxLSME
sti[balloonPopper].AvailableSpriteIdx = 2073
sti[balloonPopper].NotAvailableSpriteIdx = 2073
sti[balloonPopper].ClickedSpriteIdx = 2073

sti[M_SPELL_LIGHTNING_BOLT].OneOffMaximum = 2
sti[M_SPELL_LIGHTNING_BOLT].Cost = 100000

sti[M_SPELL_SHIELD].Cost = sti[M_SPELL_EARTHQUAKE].Cost
sti[M_SPELL_SHIELD].OneOffMaximum = 1
sti[M_SPELL_INVISIBILITY].Cost = sti[M_SPELL_EARTHQUAKE].Cost
sti[M_SPELL_INVISIBILITY].OneOffMaximum = 1

local addedTimer = 8
local timerUp = M_SPELL_HYPNOTISM
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)
for i = 0,7 do
	if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end

set_correct_gui_menu()

_constants = constants();
_constants.ShamenDeadManaPer256Gained = 8
_constants.ShamenDeadManaPer256Lost = 8
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				id = 0,
				cor = marker_to_coord3d(0),
				spellCDR = -1,
				spellc3d = 0,
				reinc = -1,
				ldb = 8,
				online = -1,
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 12,
				name = "red",
				id = 1,
				cor = marker_to_coord3d(1),
				spellCDR = -1,
				spellc3d = 0,
				reinc = -1,
				ldb = 8,
				online = -1,
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 5,
				name = "yellow",
				id = 2,
				cor = marker_to_coord3d(2),
				spellCDR = -1,
				spellc3d = 0,
				reinc = -1,
				ldb = 8,
				online = -1,
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 3,
				name = "green",
				id = 3,
				cor = marker_to_coord3d(3),
				spellCDR = -1,
				spellc3d = 0,
				reinc = -1,
				ldb = 8,
				online = -1,
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 7,
				name = "cyan",
				id = 4,
				cor = marker_to_coord3d(4),
				spellCDR = -1,
				spellc3d = 0,
				reinc = -1,
				ldb = 8,
				online = -1,
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 6,
				name = "magenta",
				id = 5,
				cor = marker_to_coord3d(5),
				spellCDR = -1,
				spellc3d = 0,
				reinc = -1,
				ldb = 8,
				online = -1,
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 16,
				name = "black",
				id = 6,
				cor = marker_to_coord3d(6),
				spellCDR = -1,
				spellc3d = 0,
				reinc = -1,
				ldb = 8,
				online = -1,
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				id = 7,
				cor = marker_to_coord3d(7),
				spellCDR = -1,
				spellc3d = 0,
				reinc = -1,
				ldb = 8,
				online = -1,
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	team1Score = b1+b2+b3
	team2Score = b4+b5+b6
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil then
			pl[i].alive = 0
			if pl[i].reinc == -1 then
				pl[i].reinc = 12*6
				--add death visual
				local Dsprite = 24
				if pl[i].ldb ~= 8 then
					Dsprite = 2083 + pl[i].ldb
				end
				local Dname = "..."
				if Dsprite ~= 24 then
					Dname = pl[pl[i].ldb].name
				end
				local Dname2 = pl[i].name
				table.insert(deaths,{Dname,Dname2,Dsprite,2083+i,12*7})
			end
		end
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
--balloons
local balloonH = 256

for i = 8,13 do
	local balloon = createThing(T_EFFECT,60,0,marker_to_coord3d(i),false,false)
	local spr = 2070 if i > 10 then spr = 2071 end
	set_thing_draw_info(balloon,TDI_SPRITE_F1_D1, spr)
	balloon.u.Effect.Duration = -1
	balloon.DrawInfo.Alpha = -16
	balloon.Pos.D3.Ypos = balloonH
	centre_coord3d_on_block(balloon.Pos.D3)
end
-----------------------------------------------
function CopyC3d(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end

--power ups 
local PupTime = 12*60 +(12*5) --first power up
local PupCDR = 12*60 + 12*G_RANDOM(15) --next power ups after first
local HealthJar = 2072 --sprite

local power1 = createThing(T_GENERAL,M_GENERAL_MAPWHO_THING,TRIBE_HOSTBOT,marker_to_coord3d(18),false,false)
power1.DrawInfo.DrawNum = HealthJar
power1.DrawInfo.Alpha = -16 --real colors


function KillBalloon(t,pn)
	if t ~= nil then
		t.DrawInfo.DrawNum = 2056
		t.u.Effect.Duration = 1
	end
	if getShaman(pn) ~= nil then
		damage_person(getShaman(pn), TRIBE_NEUTRAL, 50000, 1)
	end
end
function KillShaman(pn)
	if getShaman(pn) ~= nil then
		damage_person(getShaman(pn), TRIBE_NEUTRAL, 50000, 1)
	end
end

function PopaBalloon(pn,c3d)
	local s = createThing(T_EFFECT,10,pn,c3d,false,false)
	s.u.Effect.Duration = 12*3 + (4)
	--hit balloons
	local c2d = Coord2D.new()
	coord3D_to_coord2D(c3d, c2d)
	local blnMk = {}
	if pn < 4 then
		for i = 11,13 do table.insert(blnMk,i) end
	else
		for i = 8,10 do table.insert(blnMk,i) end
	end
	for k,v in ipairs(blnMk) do
		SearchMapCells(CIRCULAR, 0, 0 , 0, world_coord3d_to_map_idx(marker_to_coord3d(v)), function(me)
			me.MapWhoList:processList( function (t)
				if (t.Type == T_EFFECT and t.Model == 60) then
					if get_world_dist_xz(t.Pos.D2,c2d) < 256+128 then
						if v == 8 then
							b1 = b1 - 1 if b1 > 0 then KillShaman(pn) t.Pos.D3.Ypos = t.Pos.D3.Ypos + 64 queue_sound_event(nil,SND_EVENT_ACCEPT_CMD, SEF_FIXED_VARS) else queue_sound_event(nil,SND_EVENT_BALLOON_BREAK, SEF_FIXED_VARS) local mp = MapPosXZ.new() mp.Pos = world_coord2d_to_map_idx(marker_to_coord2d(v)) DELETE_SMOKE_STUFF(mp.XZ.X,mp.XZ.Z,1) KillBalloon(t,pn) end
						elseif v == 9 then
							b2 = b2 - 1 if b2 > 0 then KillShaman(pn) t.Pos.D3.Ypos = t.Pos.D3.Ypos + 64 queue_sound_event(nil,SND_EVENT_ACCEPT_CMD, SEF_FIXED_VARS) else queue_sound_event(nil,SND_EVENT_BALLOON_BREAK, SEF_FIXED_VARS) local mp = MapPosXZ.new() mp.Pos = world_coord2d_to_map_idx(marker_to_coord2d(v)) DELETE_SMOKE_STUFF(mp.XZ.X,mp.XZ.Z,1) KillBalloon(t,pn) end
						elseif v == 10 then
							b3 = b3 - 1 if b3 > 0 then KillShaman(pn) t.Pos.D3.Ypos = t.Pos.D3.Ypos + 64 queue_sound_event(nil,SND_EVENT_ACCEPT_CMD, SEF_FIXED_VARS) else queue_sound_event(nil,SND_EVENT_BALLOON_BREAK, SEF_FIXED_VARS) local mp = MapPosXZ.new() mp.Pos = world_coord2d_to_map_idx(marker_to_coord2d(v)) DELETE_SMOKE_STUFF(mp.XZ.X,mp.XZ.Z,1) KillBalloon(t,pn) end
						elseif v == 11 then
							b4 = b4 - 1 if b4 > 0 then KillShaman(pn) t.Pos.D3.Ypos = t.Pos.D3.Ypos + 64 queue_sound_event(nil,SND_EVENT_ACCEPT_CMD, SEF_FIXED_VARS) else queue_sound_event(nil,SND_EVENT_BALLOON_BREAK, SEF_FIXED_VARS) local mp = MapPosXZ.new() mp.Pos = world_coord2d_to_map_idx(marker_to_coord2d(v)) DELETE_SMOKE_STUFF(mp.XZ.X,mp.XZ.Z,1) KillBalloon(t,pn) end
						elseif v == 12 then
							b5 = b5 - 1 if b5 > 0 then KillShaman(pn) t.Pos.D3.Ypos = t.Pos.D3.Ypos + 64 queue_sound_event(nil,SND_EVENT_ACCEPT_CMD, SEF_FIXED_VARS) else queue_sound_event(nil,SND_EVENT_BALLOON_BREAK, SEF_FIXED_VARS) local mp = MapPosXZ.new() mp.Pos = world_coord2d_to_map_idx(marker_to_coord2d(v)) DELETE_SMOKE_STUFF(mp.XZ.X,mp.XZ.Z,1) KillBalloon(t,pn) end
						elseif v == 13 then
							b6 = b6 - 1 if b6 > 0 then KillShaman(pn) t.Pos.D3.Ypos = t.Pos.D3.Ypos + 64 queue_sound_event(nil,SND_EVENT_ACCEPT_CMD, SEF_FIXED_VARS) else queue_sound_event(nil,SND_EVENT_BALLOON_BREAK, SEF_FIXED_VARS) local mp = MapPosXZ.new() mp.Pos = world_coord2d_to_map_idx(marker_to_coord2d(v)) DELETE_SMOKE_STUFF(mp.XZ.X,mp.XZ.Z,1) KillBalloon(t,pn) end
						end
					end
				end
			return true end)
		return true end)
	end	
end

function DipBalloon(mk)
	SearchMapCells(CIRCULAR, 0,0,0, world_coord3d_to_map_idx(marker_to_coord3d(mk)), function(me)
		me.MapWhoList:processList( function (t)
			if (t.Type == T_EFFECT and t.Model == 60 and t.DrawInfo.DrawNum >= 2070) then
				t.Pos.D3.Ypos = t.Pos.D3.Ypos - 32
			end
		return true end)
	return true end)
end




function OnTurn()

	if win ~= 1 then AliveandOnline() end

	if win == 0 then
		--create power up
		if everySeconds(77) then
			if are_coords_on_same_map_cell(power1.Pos.D2,marker_to_coord2d(18)) > 0 then
				local PupLoc = math.random(14,17)
				move_thing_within_mapwho(power1,marker_to_coord3d(PupLoc))
				centre_coord3d_on_block(power1.Pos.D3)
				queue_sound_event(nil, SND_EVENT_BLDG_STAMP, SEF_FIXED_VARS)
			end
		end
		--catch power up
		if are_coords_on_same_map_cell(power1.Pos.D2,marker_to_coord2d(18)) == 0 then
			ProcessGlobalTypeList(T_GENERAL ,function(t)
				if t.Model == M_GENERAL_MAPWHO_THING and t.DrawInfo.DrawNum == HealthJar then
					for i = 0,7 do
						if pl[i].online == 1 and getShaman(i) ~= nil then
							if get_world_dist_xz(t.Pos.D2,getShaman(i).Pos.D2) < 256 and getShaman(i).Pos.D3.Ypos < 200 then
								move_thing_within_mapwho(power1,marker_to_coord3d(18))
								createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
								queue_sound_event(nil, SND_EVENT_DISCOBLDG_START,SEF_FIXED_VARS)
								if i < 4 then
									if b1 > 0 and b1 < 4 then
										b1 = b1 + 1 DipBalloon(8)
									elseif b2 > 0 and b2 < 4 then
										b2 = b2 + 1 DipBalloon(9)
									elseif b3 > 0 and b3 < 4 then
										b3 = b3 + 1 DipBalloon(10)
									end
								else
									if b4 > 0 and b4 < 4 then
										b4 = b4 + 1 DipBalloon(11)
									elseif b5 > 0 and b5 < 4 then
										b5 = b5 + 1 DipBalloon(12)
									elseif b6 > 0 and b6 < 4 then
										b6 = b6 + 1 DipBalloon(13)
									end
								end
							end
						end
					end
				end
			return true end)
		end
		if every2Pow(3) then
			for k = 0,7,1 do
				if pl[k].alive == 1 then
					--regive BALLOON POPPER if somehow player loses it
					if GET_NUM_ONE_OFF_SPELLS(k,balloonPopper) == 0 then
						GIVE_ONE_SHOT(balloonPopper,k)
					end
					--give MANA to players
					GIVE_MANA_TO_PLAYER (k,4096+2048)
				end
			end
		end
		--
		for i = 0,7,1 do
			--reincarnate shamans
			if pl[i].online == 1 then
				if pl[i].reinc > 0 then
					pl[i].reinc = pl[i].reinc - 1
				elseif pl[i].reinc == 0 then
					pl[i].reinc = -1
					pl[i].alive = 1
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
					centre_coord3d_on_block(getShaman(i).Pos.D3)
					if getShaman(i) ~= nil then
						getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
						getShaman(i).u.Pers.u.Owned.ShieldCount = 5
					end
				end
			end
			--process spells delay (12gt)
			if pl[i].spellCDR > 0 then
				pl[i].spellCDR = pl[i].spellCDR - 1
			elseif pl[i].spellCDR == 0 then
				pl[i].spellCDR = -1
				PopaBalloon(i,pl[i].spellc3d)
			end
		end
		--win by pts
		if team1Score == 0 or team2Score == 0 then
			if team1Score == 0 and team2Score == 0 then
				log_msg(8,"The game has ended in a tie, with both teams killing the enemy's balloons!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			if getShaman(i).Flags2 & TF2_THING_IS_AN_INVISIBLE_PERSON == 0 then
				local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
				smok.DrawInfo.Alpha = pl[i].color ; smok.u.Effect.Duration = 2
				smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
			end
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > 12 then team1Score = 12 end
	if team2Score > 12 then team2Score = 12 end
	if team1Score < 0 then team1Score = 0 end
	if team2Score < 0 then team2Score = 0 end
	if b1 > 4 then b1 = 4 end if b2 > 4 then b2 = 4 end if b3 > 4 then b3 = 4 end
	if b4 > 4 then b4 = 4 end if b5 > 4 then b5 = 4 end if b6 > 4 then b6 = 4 end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
end



function OnCreateThing(t)
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
	if win == 0 then
		if t.Type == T_EFFECT and t.Model == M_EFFECT_INSECT_PLAGUE then
			t.u.Effect.Duration = 1
		end
		if (t.Type == T_SPELL) and (t.Model == balloonPopper) then --balloon popper
			--t.Model = M_SPELL_NONE
			pl[t.Owner].spellCDR = 8
			pl[t.Owner].spellc3d = CopyC3d(t.Pos.D3)
			queue_sound_event(nil,SND_EVENT_GUARD_POST, SEF_FIXED_VARS)
		end
		if (t.Type == T_SPELL) and (t.Model == M_SPELL_SHIELD) then --shield
			--t.Model = M_SPELL_NONE
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_SHIELD] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_SHIELD] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_SHIELD] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_SHIELD] | 0
			if getShaman(t.Owner) ~= nil then
				getShaman(t.Owner).Flags3 = EnableFlag(getShaman(t.Owner).Flags3, TF3_SHIELD_ACTIVE)
				getShaman(t.Owner).u.Pers.u.Owned.ShieldCount = 8
			end
		end
		if (t.Type == T_SPELL) and (t.Model == M_SPELL_INVISIBILITY) then --invi
			--t.Model = M_SPELL_NONE
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_INVISIBILITY] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_INVISIBILITY] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_INVISIBILITY] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_INVISIBILITY] | 0
			pl[t.Owner].invi = 12*5
			if getShaman(t.Owner) ~= nil then
				getShaman(t.Owner).Flags2 = EnableFlag(getShaman(t.Owner).Flags2, TF2_THING_IS_AN_INVISIBLE_PERSON)
				getShaman(t.Owner).u.Pers.u.Owned.InvisibleCount = 8
			end
		end
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16 				- 4 - 4
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		
		--score bars
		PopSetFont(3)
		local barLen = math.floor(middle3/3)
		local barThickness = math.floor(h/32)
		--------------------------
		local percent = math.floor((b1 * 100)/4)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. b1 .. "/4"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((b2 * 100)/4)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(barLen+4+guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(barLen+4+guiW + 8,4,barLen,barThickness,1)
		DrawBox(barLen+4+guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. b2 .. "/4"
		LbDraw_Text(math.floor(barLen+4+(barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((b3 * 100)/4)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox((barLen*2)+8+guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox((barLen*2)+8+guiW + 8,4,barLen,barThickness,1)
		DrawBox((barLen*2)+8+guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. b3 .. "/4"
		LbDraw_Text(math.floor((barLen*2)+8+(barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		
		
		local percent = math.floor((b4 * 100)/4)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. b4 .. "/4"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((b5 * 100)/4)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1-4-barLen,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen-4-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen-4-barLen,4,barpercent,barThickness,14)
		local scor = "" .. b5 .. "/4"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)-4-barLen),4+2,tostring(scor),0)
		--
		local percent = math.floor((b6 * 100)/4)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1-8-(barLen*2),4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen-8-(barLen*2),4,barLen,barThickness,1)
		DrawBox(w-8-barLen-8-(barLen*2),4,barpercent,barThickness,14)
		local scor = "" .. b6 .. "/4"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)-8-(barLen*2)),4+2,tostring(scor),0)
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end
end



--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Pop-a-Balloon MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Each team has 3 balloons to defend. Each balloon has 4 hp before exploding")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Teams must defend their balloons and use the 'heater' spell to damage enemy's balloons")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Once a player casts this spell on a balloon, the balloon loses 1 hp and the shaman dies")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* Occasionally, helium jars appear on the arena. Shamans can catch them to heal 1 damaged balloon: *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- a jar heals 1 damage from a random balloon belonging to the shaman that picked it (balloon mustn't be destroyed)")
		imgui.NextColumn()
		imgui.TextUnformatted("(if the team has no balloon that can be healed by it, the powerup is simply destroyed)")
		imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Shamans have 'Invisibility' and 'Shield' spells. By casting, it affects themselves for ~4 seconds")
		imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to destroy all 3 enemy balloons is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
		imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("BALLOON HEATER - swarm")
		imgui.NextColumn()
		
		imgui.End()
	end
end

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_SHAM_INSECT) or (event == SND_EVENT_ESHAM_INSECT) or (event == SND_EVENT_SP_INSECT) or (event == SND_EVENT_SHIELD) then
		return 1
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(66,0),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2121)