--4v4 Glyph Capture Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Spells)
import(Module_Building)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}

local team1Score = 0
local team2Score = 0
----------------------------------------------------spell constants
sti = spells_type_info()
tmi = thing_move_info()

--boat
sti[M_SPELL_FLATTEN].Cost = sti[M_SPELL_FLATTEN].Cost + 20000
sti[M_SPELL_FLATTEN].OneOffMaximum = 1
sti[M_SPELL_FLATTEN].WorldCoordRange = 2048+1024
sti[M_SPELL_FLATTEN].CursorSpriteNum = 116
sti[M_SPELL_FLATTEN].ToolTipStrIdx = sti[M_SPELL_EROSION].ToolTipStrIdx
sti[M_SPELL_FLATTEN].ToolTipStrIdxLSME = sti[M_SPELL_EROSION].ToolTipStrIdxLSME
sti[M_SPELL_FLATTEN].AvailableSpriteIdx = 654
sti[M_SPELL_FLATTEN].NotAvailableSpriteIdx = 654
sti[M_SPELL_FLATTEN].ClickedSpriteIdx = 654

sti[M_SPELL_GHOST_ARMY].Cost = math.floor(sti[M_SPELL_INSECT_PLAGUE].Cost*2.5)
sti[M_SPELL_GHOST_ARMY].OneOffMaximum = 2

sti[M_SPELL_BLAST].OneOffMaximum = 4

sti[M_SPELL_LIGHTNING_BOLT].OneOffMaximum = 3
sti[M_SPELL_LIGHTNING_BOLT].Cost = 60000

local addedTimer = 10
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)


giveSpells = {M_SPELL_BLAST,M_SPELL_GHOST_ARMY,M_SPELL_LIGHTNING_BOLT,M_SPELL_FLATTEN}

tmi[TMI_PERSON_MEDICINE_MAN].BaseSpeed = 68
set_correct_gui_menu()

_constants = constants();
_constants.ShamenDeadManaPer256Gained = 8
_constants.ShamenDeadManaPer256Lost = 8
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				alive = 1,
				color = -10,
				drawClr = 4,
				name = "blue",
				id = 0,
				cor = marker_to_coord3d(0),
				spell = 0,
				spellCDR = -1,
				spellc3d = 0,
				finished = 0,
				online = -1,
				score = 0,
				ldb = 8,
				reinc = -1
			},
			{
				alive = 1,
				color = -14,
				drawClr = 12,
				name = "red",
				id = 1,
				cor = marker_to_coord3d(1),
				spell = 0,
				spellCDR = -1,
				spellc3d = 0,
				finished = 0,
				online = -1,
				score = 0,
				ldb = 8,
				reinc = -1
			},
			{
				alive = 1,
				color = -9,
				drawClr = 5,
				name = "yellow",
				id = 2,
				cor = marker_to_coord3d(2),
				spell = 0,
				spellCDR = -1,
				spellc3d = 0,
				finished = 0,
				online = -1,
				score = 0,
				ldb = 8,
				reinc = -1
			},
			{
				alive = 1,
				color = -11,
				drawClr = 3,
				name = "green",
				id = 3,
				cor = marker_to_coord3d(3),
				spell = 0,
				spellCDR = -1,
				spellc3d = 0,
				finished = 0,
				online = -1,
				score = 0,
				ldb = 8,
				reinc = -1
			},
			{
				alive = 1,
				color = -2,
				drawClr = 7,
				name = "cyan",
				id = 4,
				cor = marker_to_coord3d(4),
				spell = 0,
				spellCDR = -1,
				spellc3d = 0,
				finished = 0,
				online = -1,
				score = 0,
				ldb = 8,
				reinc = -1
			},
			{
				alive = 1,
				color = -1,
				drawClr = 6,
				name = "magenta",
				id = 5,
				cor = marker_to_coord3d(5),
				spell = 0,
				spellCDR = -1,
				spellc3d = 0,
				finished = 0,
				online = -1,
				score = 0,
				ldb = 8,
				reinc = -1
			},
			{
				alive = 1,
				color = 0,
				drawClr = 16,
				name = "black",
				id = 6,
				cor = marker_to_coord3d(6),
				spell = 0,
				spellCDR = -1,
				spellc3d = 0,
				finished = 0,
				online = -1,
				score = 0,
				ldb = 8,
				reinc = -1
			},
			{
				alive = 1,
				color = -3,
				drawClr = 2,
				name = "orange",
				id = 7,
				cor = marker_to_coord3d(7),
				spellCDR = -1,
				spellc3d = 0,
				finished = 0,
				online = -1,
				score = 0,
				ldb = 8,
				reinc = -1
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--[[if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			end]]
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
		if getShaman(i) == nil and pl[i].reinc == -1 then
			pl[i].alive = 0
			pl[i].reinc = 12*5
			--add death visual
			local Dsprite = 24
			if pl[i].ldb ~= 8 then
				Dsprite = 2083 + pl[i].ldb
			end
			local Dname = "..."
			if Dsprite ~= 24 then
				Dname = pl[pl[i].ldb].name
			end
			local Dname2 = pl[i].name
			table.insert(deaths,{Dname,Dname2,Dsprite,2083+i,12*7})
		end
	end
end
---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
function CopyC3d(c3d)
  local nc3d = Coord3D.new();
  nc3d.Xpos = c3d.Xpos;
  nc3d.Ypos = c3d.Ypos;
  nc3d.Zpos = c3d.Zpos;
  return nc3d;
end

unwalkableZones = {20,21}
for k,v in ipairs(unwalkableZones) do
	local mk2c3d = marker_to_coord3d(v)
	SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(mk2c3d), function(me)
		me.Flags = EnableFlag(me.Flags, (1<<2))
		me.Flags = EnableFlag(me.Flags, (1<<19))
	return true
	end)
end

--create glyphs
glyphLoc = {}
for i = 30,109,1 do
	table.insert(glyphLoc,i)
end
local glyphH = 512 --main height
for k,v in ipairs(glyphLoc) do
	local g = createThing(T_EFFECT,60,8,marker_to_coord3d(v),false,false)
	set_thing_draw_info(g,TDI_SPRITE_F8_D1_ALPHA, 1779)
	g.u.Effect.Duration = -1
	g.Pos.D3.Ypos = point_altitude(g.Pos.D3.Xpos,g.Pos.D3.Zpos) + glyphH
	centre_coord3d_on_block(g.Pos.D3)
	for p = 0,7 do
		for j = 0,10 do
			if v == 30+p+(j*8) then
				g.DrawInfo.Alpha = pl[p].color
			end
		end
	end
end

function CreateBoat(pn,c3d)
	local function RegiveBoat()
		local shots = GET_NUM_ONE_OFF_SPELLS(pn,M_SPELL_FLATTEN)
		_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[M_SPELL_FLATTEN] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[M_SPELL_FLATTEN] & 240
		_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[M_SPELL_FLATTEN] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[M_SPELL_FLATTEN] | shots+1
	end
	queue_sound_event(nil,SND_EVENT_W_SPLASH, SEF_FIXED_VARS)
	createThing(T_EFFECT,M_EFFECT_SPLASH,8,c3d,false,false)
	SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(c3d), function(me)
		if (is_map_elem_all_land(me) == 0) and _gsi.Players[pn].NumVehiclesOfType[M_VEHICLE_BOAT_1] < 3 then
			 createThing(T_VEHICLE ,M_VEHICLE_BOAT_1 ,pn,c3d,false,false)
		else
			RegiveBoat()
		end
	return true
	end)
end




function OnTurn()

	if win ~= 1 then AliveandOnline() end

	if win == 0 then
		for i = 0,7,1 do
			--process boat spell cdr
			if pl[i].spellCDR > 0 then
				pl[i].spellCDR = pl[i].spellCDR - 1
			elseif pl[i].spellCDR == 0 then
				pl[i].spellCDR = -1
				CreateBoat(i,pl[i].spellc3d)
			end
			--approach glyphs
			for k = 9,18,1 do
				if getShaman(i) ~= nil and getShaman(i).u.Pers.Life > 0 and IS_SHAMAN_IN_AREA(i,k,2) == 1 then
					SearchMapCells(SQUARE, 0, 0, 0, world_coord3d_to_map_idx(marker_to_coord3d(30+i+(8*(k-9)))), function(me)
						me.MapWhoList:processList(function(t)
							if (t.Type == T_EFFECT) and (t.Model == 60) then
								if t.Pos.D3.Ypos < point_altitude(t.Pos.D3.Xpos,t.Pos.D3.Zpos) + glyphH + 1024 then
									t.Pos.D3.Ypos = t.Pos.D3.Ypos + 6
								else
									--got glyph!
									queue_sound_event(nil,SND_EVENT_HYPNOTISE, SEF_FIXED_VARS)
									local a = createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
									local a = createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
									local a = createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
									pl[i].score = pl[i].score + 1
									move_thing_within_mapwho(t,marker_to_coord3d(22)) ; t.Pos.D3.Ypos = 0
									if pl[i].score >= 10 then
										pl[i].score = 10
										pl[i].finished = 1
									end
									if i < 4 then
										team1Score = team1Score + 1
									else
										team2Score = team2Score + 1
									end
								end
							end
						return true end)
					return true end)
				else
					SearchMapCells(SQUARE, 0, 0, 0, world_coord3d_to_map_idx(marker_to_coord3d((30+i+(8*(k-9))))), function(me)
						me.MapWhoList:processList(function(t)
							if (t.Type == T_EFFECT) and (t.Model == 60) then
								if t.Pos.D3.Ypos > point_altitude(t.Pos.D3.Xpos,t.Pos.D3.Zpos) + glyphH then
									t.Pos.D3.Ypos = t.Pos.D3.Ypos - 12
								end
							end
						return true end)
					return true end)
				end
			end
		end
		if every2Pow(2) then
			--mana
			for i = 0,7,1 do
				GIVE_MANA_TO_PLAYER (i,2048+1024)
			end
		end
		--[[if everySeconds(5) then
			for i = 0,7 do
				--reinc shaman who die
				if getShaman(i) == nil and pl[i].online == 1 then
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
					if getShaman(i) ~= nil then
						getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
						getShaman(i).u.Pers.u.Owned.ShieldCount = 10
					end
				end
			end
		end]]
		--revive shamans
		for i = 0,7 do
			if pl[i].online == 1 then
				if getShaman(i) == nil and pl[i].reinc > 0 then
					pl[i].reinc = pl[i].reinc - 1
				elseif getShaman(i) == nil and pl[i].reinc == 0 then
					createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
					if getShaman(i) ~= nil then
						getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
						getShaman(i).u.Pers.u.Owned.ShieldCount = 10
					end
					pl[i].alive = 1
					pl[i].reinc = -1
				end
			end
		end
		--win by pts
		if team1Score == 40 or team2Score == 40 then
			if team1Score == 40 and team2Score == 40 then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.u.Effect.Duration = 2
			if i < 4 then
				smok.DrawInfo.Alpha = 2
			else
				smok.DrawInfo.Alpha = -1
			end
			smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
			if is_person_driver_in_any_vehicle(getShaman(i)) == 1 then
				smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 196
			end
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		for i = 0,7 do
			for k,v in ipairs(giveSpells) do
				set_player_can_cast(v,i)
			end
			if getShaman(i) ~= nil then
				getShaman(i).Flags3 = EnableFlag(getShaman(i).Flags3, TF3_SHIELD_ACTIVE)
				getShaman(i).u.Pers.u.Owned.ShieldCount = 6
			end
		end
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > 40 then team1Score = 40 end
	if team2Score > 40 then team2Score = 40 end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--kill ghost shamans
	ProcessGlobalSpecialListAll(PEOPLELIST, function(t)
		if t.Model == M_PERSON_MEDICINE_MAN and (t.Flags2 & TF2_THING_IS_A_GHOST_PERSON > 0) then
			damage_person(t, 8, 20000, TRUE)
		end
	return true end)
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			pl[i].ldb = getShaman(i).u.Pers.u.Owned.LastDamagedBy
		end
	end
end



function OnCreateThing(t)
	if t.Type == T_EFFECT and t.Model == M_SPELL_FLATTEN then
		t.u.Effect.Duration = 1
	end
	if (t.Type == T_SPELL) and (t.Model == M_SPELL_FLATTEN) then --boat spawner
		--t.Model = M_SPELL_NONE
		pl[t.Owner].spellCDR = 8
		pl[t.Owner].spellc3d = CopyC3d(t.Pos.D3)
		local ptb = GET_NUM_ONE_OFF_SPELLS(t.Owner,M_SPELL_FLATTEN)
		if ptb > 0 then
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_FLATTEN] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_FLATTEN] & 240
			_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_FLATTEN] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[M_SPELL_FLATTEN] | ptb-1
		end
		local newS = createThing(T_SPELL, M_SPELL_SHIELD, t.Owner, t.Pos.D3, false, false)
	end
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/40)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		--local scor = "" .. team1Score .. "/40"
		--LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		local scores1 = "" .. pl[0].score .. "/10" .. "    " .. pl[1].score .. "/10" .. "    " .. pl[2].score .. "/10" .. "    " .. pl[3].score .. "/10"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scores1))/2)),4+2,tostring(scores1),0)
		--
		local percent = math.floor((team2Score * 100)/40)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		--local scor = "" .. team2Score .. "/40"
		--LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		local scores2 = "" .. pl[4].score .. "/10" .. "    " .. pl[5].score .. "/10" .. "    " .. pl[6].score .. "/10" .. "    " .. pl[7].score .. "/10"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scores2))/2)),4+2,tostring(scores2),0)
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end	
end



--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)

		imgui.TextUnformatted("Glyph Capture MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Teams roam the land, capturing glyphs that are located in 10 different zones")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Each shaman must capture 10 glyphs of their color (totalling 40 glyphs per team)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("- To capture a glyph, get near the location, and remain there for some seconds (leaving the zone will reverse the capturing)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* There is a 'boat' spell that creates a boat (must be cast on water) *")
	   	imgui.NextColumn()
		imgui.TextUnformatted("* (this spell doesn't work on land, or if the player has 3 or more boats already) *")
		imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("NOTE: if a player leaves the game before capturing their 10 glyphs, their team will be unable to reach the points objective:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("they can only win if the timer ends and they have more captured glyphs")
	   	imgui.NextColumn()
		imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("BOAT SPAWNER - flatten")
		
		imgui.End()
	end
end

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_SHAM_FLATTEN) or (event == SND_EVENT_ESHAM_FLATTEN) then
		return 1
	end
end

draw_sky_clr_overlay(3,-1)


--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(50,36),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2122)