-- 4v4 Grave Diggers Minigame

import(Module_System)
import(Module_Players)
import(Module_Defines)
import(Module_PopScript)
import(Module_Game)
import(Module_Objects)
import(Module_Map)
import(Module_Math)
import(Module_MapWho)
import(Module_String)
import(Module_ImGui)
import(Module_Draw)
import(Module_System)
import(Module_Globals)
import(Module_Person)
import(Module_Table)
import(Module_DataTypes)
import(Module_Sound)
import(Module_Commands)
import(Module_Level)
import(Module_Building)
import(Module_Spells)
include("zz4_assets.lua")
for i = 0,7 do set_player_cannot_build(M_BUILDING_GUARD_POST, i) end
--teams old vs new tribes
for i = 0,3 do
	for j = 0,3 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
for i = 4,7 do
	for j = 4,7 do
		if j ~= i then
			set_players_allied(i,j)
			set_players_allied(j,i)
		end
	end
end
local gs = gsi()
local gns = gnsi()
_gnsi = gnsi()
_gsi = gsi()

for i=0,7 do
  set_player_reinc_site_off(getPlayer(i))
  SET_NO_REINC(i)
  if getShaman(i) ~= nil then
		getShaman(i).Flags = EnableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
	end
end
_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 | GPF2_GAME_NO_WIN
_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 | GPF3_NO_GAME_OVER_PROCESS

sinkTable = {}
local afterRegenTimer = -1
local stagedance = -1

local win = -1
local timer = -1
local exptimer = 12*10 + 12
local captains = {0,7}
local Noncaptains = {1,2,3,4,5,6}
local stagepause = -1

local team1Score = 0
local team2Score = 0
----------------------------------------------------spell constants
sti = spells_type_info()
tmi = thing_move_info()

local lower = M_SPELL_INSECT_PLAGUE
sti[lower].Cost = sti[M_SPELL_BLAST].Cost
sti[lower].OneOffMaximum = 1
sti[lower].WorldCoordRange = 1024*4
sti[lower].CursorSpriteNum = 167
sti[lower].AvailableSpriteIdx = 2143
sti[lower].NotAvailableSpriteIdx = 2143
sti[lower].ClickedSpriteIdx = 2143

local rise = M_SPELL_FIRESTORM 
sti[rise].Cost = sti[M_SPELL_LIGHTNING_BOLT].Cost
sti[rise].OneOffMaximum = 2
sti[rise].WorldCoordRange = 1024*4
sti[rise].CursorSpriteNum = 168
sti[rise].AvailableSpriteIdx = 2142
sti[rise].NotAvailableSpriteIdx = 2142
sti[rise].ClickedSpriteIdx = 2142

local addedTimer = 8
local timerUp = M_SPELL_SHIELD
sti[timerUp].OneOffMaximum = 1
sti[timerUp].WorldCoordRange = 4096
sti[timerUp].CursorSpriteNum = 27
sti[timerUp].AvailableSpriteIdx = 2099
sti[timerUp].NotAvailableSpriteIdx = 2099
sti[timerUp].ClickedSpriteIdx = 2099
local timerDown = M_SPELL_CONVERT_WILD
sti[timerDown].OneOffMaximum = 1
sti[timerDown].WorldCoordRange = 4096
sti[timerDown].CursorSpriteNum = 27
sti[timerDown].AvailableSpriteIdx = 2100
sti[timerDown].NotAvailableSpriteIdx = 2100
sti[timerDown].ClickedSpriteIdx = 2100
set_player_can_cast(timerDown,0)
set_player_can_cast(timerUp,0)
GIVE_ONE_SHOT(timerDown,0)
GIVE_ONE_SHOT(timerUp,0)

set_correct_gui_menu()

_constants = constants();
_constants.ShamenDeadManaPer256Gained = 8
_constants.ShamenDeadManaPer256Lost = 8
_constants.FirestormDuration = 48
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
pl = {
			[0] =
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 4,
				name = "blue",
				id = 0,
				cor = marker_to_coord3d(0),
				spellCDR = -1,
				spellc3d = 0,
				spellCDR2 = -1,
				spellc3d2 = 0,
				online = -1,
				reinc = -1
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 12,
				name = "red",
				id = 1,
				cor = marker_to_coord3d(1),
				spellCDR = -1,
				spellc3d = 0,
				spellCDR2 = -1,
				spellc3d2 = 0,
				online = -1,
				reinc = -1
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 5,
				name = "yellow",
				id = 2,
				cor = marker_to_coord3d(2),
				spellCDR = -1,
				spellc3d = 0,
				spellCDR2 = -1,
				spellc3d2 = 0,
				online = -1,
				reinc = -1
			},
			{
				score = 0,
				alive = 1,
				color = 2,
				drawClr = 3,
				name = "green",
				id = 3,
				cor = marker_to_coord3d(3),
				spellCDR = -1,
				spellc3d = 0,
				spellCDR2 = -1,
				spellc3d2 = 0,
				online = -1,
				reinc = -1
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 7,
				name = "cyan",
				id = 4,
				cor = marker_to_coord3d(4),
				spellCDR = -1,
				spellc3d = 0,
				spellCDR2 = -1,
				spellc3d2 = 0,
				online = -1,
				reinc = -1
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 6,
				name = "magenta",
				id = 5,
				cor = marker_to_coord3d(5),
				spellCDR = -1,
				spellc3d = 0,
				spellCDR2 = -1,
				spellc3d2 = 0,
				online = -1,
				reinc = -1
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 16,
				name = "black",
				id = 6,
				cor = marker_to_coord3d(6),
				spellCDR = -1,
				spellc3d = 0,
				spellCDR2 = -1,
				spellc3d2 = 0,
				online = -1,
				reinc = -1
			},
			{
				score = 0,
				alive = 1,
				color = 9,
				drawClr = 2,
				name = "orange",
				id = 7,
				cor = marker_to_coord3d(7),
				spellCDR = -1,
				spellc3d = 0,
				spellCDR2 = -1,
				spellc3d2 = 0,
				online = -1,
				reinc = -1
			}
}
--set player names and online status
for pn = 0,7,1 do
	if ((_gnsi.Flags & GNS_NETWORK) == GNS_NETWORK) then
		pl[pn].name = get_player_name(pn, true)
		local name = #pl[pn].name
		if name > 8 then
			smallName = ""
			for i = 1,8 do
				smallName = smallName .. string.sub(pl[pn].name, i, i) 
			end
			pl[pn].name = smallName
		end
	end
	if _gsi.Players[pn].PlayerActive == 1 and _gsi.Players[pn].DeadCount == 0 then
		pl[pn].online = 1
	else
		pl[pn].online = 0
		pl[pn].name = "NoPlayer" .. tostring(pn+1) .. ""
		pl[pn].alive = 0
	end

end

function AliveandOnline()
	for i = 0,7,1 do
		if _gsi.Players[i].PlayerActive == 1 and _gsi.Players[0].DeadCount == 0 then
			pl[i].online = 1
		else
			pl[i].online = 0
			pl[i].alive = 0
			--if (string.sub(pl[i].name, 1, 1) ~= "*") and (string.sub(pl[i].name, 1, 8) ~= "NoPlayer") then
				--pl[i].name = "*" .. pl[i].name .. "" --disconnected symbol on scoreboard
			--end
			if getShaman(i) ~= nil then
				getShaman(i).u.Pers.Life = 0
			end
		end
	end
end

--create reedy grass (arena delimitator)
waterSink = {}
for i = 10,81,1 do
	table.insert(waterSink,i)
end
for k,v in ipairs(waterSink) do
	local a = createThing(T_EFFECT, M_EFFECT_REEDY_GRASS , 8, marker_to_coord3d(v), false, false)
	centre_coord3d_on_block(a.Pos.D3)
end

local arenaBorders = {}
for i = 152,215 do table.insert(arenaBorders,i) end

function ArenaBorderSpell(coord3d)
	local c2d = Coord2D.new()
	coord3D_to_coord2D(coord3d,c2d)
	local look = 0
	for k,v in ipairs(arenaBorders) do
		if are_coords_on_same_map_cell(c2d,marker_to_coord2d(v)) == 1 then
			look = 1
			break
		end
	end
	return look
end

function LowerFloor(c3d)
	local altitude = c3d.Ypos
	local cast = ArenaBorderSpell(c3d)
	SearchMapCells(SQUARE,0,0,1,world_coord3d_to_map_idx(c3d), function (me)
		--if (is_map_cell_near_coast(world_coord3d_to_map_idx(c3d),1) == 0) then
		if cast == 0 then
			if altitude - 128 > -1 then
				me.Alt = altitude - 128
			else
				me.Alt = -1
			end
		end
		set_square_map_params(world_coord3d_to_map_idx(c3d),8,TRUE)
		createThing(T_EFFECT, M_EFFECT_SMOKE, 8, c3d, false, false)
	return true
	end)
	queue_sound_event(nil, SND_EVENT_SHRAPNEL, SEF_FIXED_VARS)
end

function RiseFloor(c3d)
	local altitude = c3d.Ypos
	local cast = ArenaBorderSpell(c3d)
	SearchMapCells(SQUARE,0,0,1,world_coord3d_to_map_idx(c3d), function (me)
		--if (is_map_cell_near_coast(world_coord3d_to_map_idx(c3d),1) == 0) then
		if cast == 0 then
			if altitude + 128 < 1023 then
				me.Alt = altitude + 128
			else
				me.Alt = 1023
			end
		end
		set_square_map_params(world_coord3d_to_map_idx(c3d),8,TRUE)
		createThing(T_EFFECT, M_EFFECT_WW_DUST, 8, c3d, false, false)
	return true
	end)
	queue_sound_event(nil, SND_EVENT_DROP_WOOD, SEF_FIXED_VARS)
end


--for regen phase, helps in 2 directions that are bugged and need extra rise on odd coordinates
local test = {}
local m1 = MapPosXZ.new()
for z= -14,12 do
	m1.XZ.X = 14
	m1.XZ.Z = z
	table.insert(test, m1.Pos)
end
for x= -12,14 do
	m1.XZ.X = x
	m1.XZ.Z = 12
	table.insert(test, m1.Pos)
end


function RegenerateFloor()
	SearchMapCells(SQUARE,0,0,7,world_coord3d_to_map_idx(marker_to_coord3d(8)), function (me)
		me.Alt = 1023
		set_square_map_params(world_coord3d_to_map_idx(marker_to_coord3d(8)),8,TRUE)
		me.Flags = DisableFlag(me.Flags, (1<<2))
		me.Flags = DisableFlag(me.Flags, (1<<19))
	return true
	end)
	queue_sound_event(nil, SND_EVENT_LANDSPLIT, SEF_FIXED_VARS)
	afterRegenTimer = 12
	--
	for pn = 0,7,1 do
		_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[rise] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[rise] & 240
		_gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[rise] = _gsi.ThisLevelInfo.PlayerThings[pn].SpellsAvailableOnce[rise] | 0
	end
	--cast rise spells all around, to help regen borders of arena
	for i,v in ipairs(test) do
		SearchMapCells(SQUARE,0,0,1,v, function (me)
			me.Alt = 1023
			set_square_map_params(world_coord3d_to_map_idx(marker_to_coord3d(v)),1,TRUE)
			me.Flags = DisableFlag(me.Flags, (1<<2))
			me.Flags = DisableFlag(me.Flags, (1<<19))
		return true
		end)
	end
	--clean border cliffs
	for i = 149,150 do
		SearchMapCells(SQUARE,0,0,1,world_coord3d_to_map_idx(marker_to_coord3d(i)), function (me)
			me.Alt = 1023
			set_square_map_params(world_coord3d_to_map_idx(marker_to_coord3d(i)),8,TRUE)
		return true end)
	end
end


function CheckIfTeamDeath()
	local ded = 0
	for i = 0,3 do
		if getShaman(i) == nil then
			ded = ded + 1
		end
	end
	local ded2 = 0
	for i = 4,7 do
		if getShaman(i) == nil then
			ded2 = ded2 + 1
		end
	end
	if ded == 4 or ded2 == 4 then
		stagepause = 12*6
		for i = 0,7 do
			set_player_cannot_cast(lower,i)
			set_player_cannot_cast(rise,i)
		end
		queue_sound_event(nil,SND_EVENT_SHAMKILL_SWIRL, SEF_FIXED_VARS)
	end
end

function MidPause()
	local ded = 0
	for i = 0,3 do
		if getShaman(i) == nil then
			ded = ded + 1
		end
	end
	local ded2 = 0
	for i = 4,7 do
		if getShaman(i) == nil then
			ded2 = ded2 + 1
		end
	end
	if ded == 4 and ded2 == 4 then
		team1Score = team1Score + 1
		team2Score = team2Score + 1
	elseif ded == 4 then --team2 won
		team2Score = team2Score + (4-ded2)
	elseif ded2 == 4 then --team1 won
		team1Score = team1Score + (4-ded)
	end
	for i = 0,7 do
		if getShaman(i) ~= nil then
			for j = 0,3 do
				local s = createThing(T_EFFECT,M_EFFECT_ORBITER,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
				s.DrawInfo.Alpha = pl[i].color
			end
		end
	end
end

function NewRound()
	for i = 0,7 do
		set_player_can_cast(lower,i)
		set_player_can_cast(rise,i)
		if pl[i].online == 1 and getShaman(i) == nil then
			createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
			pl[i].reinc = -1
		end
	end
	queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
end


function OnTurn()

	if win ~= 1 then AliveandOnline() end

	if win == 0 then
		--check for team death
		if stagepause == -1 then
			CheckIfTeamDeath()
		elseif stagepause == 12*3 then
			MidPause()
		elseif stagepause == 12*1 then
			RegenerateFloor()
		end
		--stagepause
		if stagepause > 0 then
			stagepause = stagepause - 1
		elseif stagepause == 0 then
			stagepause = -1
			NewRound()
		end
		--dont let players lose the "lower" spell
		for k = 0,7,1 do
			if GET_NUM_ONE_OFF_SPELLS(k,lower) == 0 and stagepause == -1 then
				GIVE_ONE_SHOT(lower,k)
			end
		end
		if every2Pow(3) then
			--KILL PPL WHO ARE LOW GROUND/WATER
			for i = 0,7,1 do
				if getShaman(i) ~= nil then 
					if getShaman(i).Pos.D3.Ypos < 6 then
						createThing(T_EFFECT,M_EFFECT_SPLASH,TRIBE_NEUTRAL,getShaman(i).Pos.D3,false,false)
						damage_person(getShaman(i), TRIBE_NEUTRAL, 5000, 1)
					end
				end
			end
			--KILL PPL WHO LEAVE ARENA
			KILL_TEAM_IN_AREA(38,254,11)
			KILL_TEAM_IN_AREA(0,216,11)
			KILL_TEAM_IN_AREA(0,36,11)
			KILL_TEAM_IN_AREA(218,254,11)
		end
		--give rise spell
		if every2Pow(6) and stagepause == -1 then
			for k = 0,7,1 do
				if pl[k].alive == 1 then
					if GET_NUM_ONE_OFF_SPELLS(k,rise) <= 1 then
						GIVE_ONE_SHOT(rise,k)
					end
				end
			end	
		end
		--death text
		for i = 0,7 do
			if pl[i].online == 1 and pl[i].reinc == -1 then
				if getShaman(i) == nil then
					pl[i].reinc = 0
					local Dsprite = 2144
					local Dname = ""
					local Dname2 = pl[i].name
					table.insert(deaths,{Dname,Dname2,Dsprite,2083+i,12*7})
				end
			end
		end
		--process spells delay (12gt)
		for i = 0,7,1 do
			if pl[i].spellCDR > 0 then --lower
				pl[i].spellCDR = pl[i].spellCDR - 1
			elseif pl[i].spellCDR == 0 then
				pl[i].spellCDR = -1
				LowerFloor(pl[i].spellc3d)
			end
			if pl[i].spellCDR2 > 0 then --rise
				pl[i].spellCDR2 = pl[i].spellCDR2 - 1
			elseif pl[i].spellCDR2 == 0 then
				pl[i].spellCDR2 = -1
				RiseFloor(pl[i].spellc3d2)
			end
		end
		--win by pts
		if team1Score == 15 or team2Score == 15 then
			if team1Score == 15 and team2Score == 15 then
				log_msg(8,"The game has ended in a tie, with both teams reaching the maximum score!")
				timer = -1
				win = 1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				for i = 0,7 do
					if getShaman(i) == nil then
						createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
						centre_coord3d_on_block(getShaman(i).Pos.D3)
					end
					gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
				end
			else
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			end
		end
		if timer > 0 then
			timer = timer -1
		elseif timer == 0 then
			if team1Score ~= team2Score then
				win = 1
				timer = -1
				_gnsi.GameParams.Flags2 = _gnsi.GameParams.Flags2 & ~GPF2_GAME_NO_WIN
				_gnsi.GameParams.Flags3 = _gnsi.GameParams.Flags3 & ~GPF3_NO_GAME_OVER_PROCESS
				if team1Score > team2Score then
					log_msg(8,"The game has ended. Blue team is victorious!")
					for i = 4,7 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 0,3 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				else
					log_msg(8,"The game has ended. Orange team is victorious!")
					for i = 0,3 do
						SET_NO_REINC(i)
						ProcessGlobalSpecialList(i, PEOPLELIST, function(t)
							damage_person(t, 8, 20000, TRUE)
							return true
						end)
						gns.Flags = gns.Flags | GNS_LEVEL_FAILED
					end
					for i = 4,7 do
						if getShaman(i) == nil then
							createThing(T_PERSON,M_PERSON_MEDICINE_MAN,i,pl[i].cor,false,false)
							centre_coord3d_on_block(getShaman(i).Pos.D3)
						end
						gns.Flags = gns.Flags | GNS_LEVEL_COMPLETE
					end
				end
			else
				log_msg(8,"The game is tied. 30 seconds have been added.")
				timer = 12*31
			end
		end
	end
	--draw sparkles on heads
	for i = 0,7 do
		if getShaman(i) ~= nil then
			local smok = createThing(T_EFFECT,M_EFFECT_SMALL_SPARKLE,TRIBE_HOSTBOT,getShaman(i).Pos.D3,false,false)
			smok.DrawInfo.Alpha = pl[i].color ; smok.u.Effect.Duration = 2
			smok.Pos.D3.Ypos = smok.Pos.D3.Ypos + 32
		end
	end
	--exp timer going down
	if exptimer > 0 then
		exptimer = exptimer - 1
	elseif exptimer == 0 then
		exptimer = -1
		win = 0
		timer = 12+ 12*60*addedTimer
		queue_sound_event(nil,SND_EVENT_FIGHT_ALARM, SEF_FIXED_VARS)
		set_player_cannot_cast(timerUp,0) set_player_cannot_cast(timerDown,0)
		for i = 0,7 do
			set_player_can_cast(lower,i)
			set_player_can_cast(rise,i)
			_gsi.ThisLevelInfo.PlayerThings[i].SpellsNotCharging = EnableFlag(_gsi.ThisLevelInfo.PlayerThings[i].SpellsNotCharging, (1 << (lower - 1)))
			if getShaman(i) ~= nil then
				getShaman(i).Flags = DisableFlag(getShaman(i).Flags, TF_STATE_LOCKED)
			end
		end
		set_correct_gui_menu()
	end
	--reset score if too big
	if team1Score > 15 then team1Score = 15 end
	if team2Score > 15 then team2Score = 15 end
	if team1Score < 0 then team1Score = 0 end
	if team2Score < 0 then team2Score = 0 end
	--deselect shamans before game starts
	if win == -1 then
		for i = 0,7,1 do
			DESELECT_ALL_PEOPLE(i)
		end
	end
	--process shamans not being targetable
	ProcessGlobalSpecialListAll(0, function(targ)
		if (targ.Type == T_PERSON) and (targ.Model == M_PERSON_MEDICINE_MAN) then
			local cmd = get_thing_curr_cmd_list_ptr(targ)
			if (cmd ~= nil) then
				if (cmd.CommandType == CMD_ATTACK_AREA_2) or (cmd.CommandType == CMD_ATTACK_TARGET) then
					cmd.CommandType = CMD_HEAD_PRAY
				end
			end
		end
	return true
	end)
	--last damaged by
	if #deaths > 0 then
		for i = 1,#deaths do
			if i <= #deaths then
				if deaths[i][5] > 0 then
					deaths[i][5] = deaths[i][5] - 1
				elseif deaths[i][5] == 0 then
					table.remove(deaths,i)
					--break
				end
			end
		end
	end
end



local dropIcon = 0
function OnCreateThing(t)
	if t.Type == T_SPELL then
		KILL_ALL_MSG_ID(dropIcon)
		dropIcon = dropIcon + 1
		CLEAR_ALL_MSG()
	end
	--host can rise or lower the game time
	if win == -1 then
		if t.Type == T_SPELL then
			if t.Owner == 0 then
				if t.Model == timerUp then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[t.Model] | 2
					addedTimer = addedTimer + 1
					log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
				elseif t.Model == timerDown then
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] & 240
					_gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] = _gsi.ThisLevelInfo.PlayerThings[t.Owner].SpellsAvailableOnce[timerDown] | 2
					addedTimer = addedTimer - 1
					if addedTimer <= 1 then
						addedTimer = 1
						log_msg(8,"The host has set the game to 1 minute")
					else
						log_msg(8,"The host has set the game to " .. addedTimer .. " minutes")
					end
				end
			end
		end
	end
	if (t.Type == T_SPELL) and win == 0 then
		local water = 0
		if (t.Model == lower) and getShaman(t.Owner) ~= nil then --LOWER
			SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(t.Pos.D3), function(me)
				if (is_map_elem_sea_or_coast(me) == 2) then
					water = 1
				end
			return true
			end)
			if water == 0 then
				pl[t.Owner].spellCDR = 8
				pl[t.Owner].spellc3d = CopyC3d(t.Pos.D3)
			end
		elseif (t.Model == rise) and getShaman(t.Owner) ~= nil then --LOWER
			SearchMapCells(SQUARE, 0, 0 , 0, world_coord3d_to_map_idx(t.Pos.D3), function(me)
				if (is_map_elem_sea_or_coast(me) == 2) then
					water = 1
				end
			return true
			end)
			if water == 0 then
				pl[t.Owner].spellCDR2 = 8
				pl[t.Owner].spellc3d2 = CopyC3d(t.Pos.D3)
			end
		end
	end
	if t.Type == T_EFFECT and (t.Model == M_EFFECT_INSECT_PLAGUE or t.Model == M_EFFECT_FIRESTORM) then
		t.u.Effect.Duration = 1
	end
end



function OnFrame()
	if _gnsi.PlayerNum >= 0 and pl[_gnsi.PlayerNum].online == 1 then
		local w = ScreenWidth()
		local h = ScreenHeight()
		local guiW = GFGetGuiWidth()
		--local middle = math.floor ((w)/2)
		local middle2 = math.floor((w+guiW)/2)
		local middle3 = math.floor((w-guiW)/2) - 8 - 8 - 16
		local box = math.floor(h/22)
		local box2 = math.floor(h/32)
		
		--score bars
		PopSetFont(3)
		local barLen = middle3
		local barThickness = math.floor(h/32)
		local percent = math.floor((team1Score * 100)/15)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(guiW + 8-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(guiW + 8,4,barLen,barThickness,1)
		DrawBox(guiW + 8,4,barpercent,barThickness,4)
		local scor = "" .. team1Score .. "/15"
		LbDraw_Text(math.floor((barLen/2)+guiW+8-(string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		--
		local percent = math.floor((team2Score * 100)/15)
		local barpercent = math.floor((barLen * percent) / 100)
		DrawBox(w-8-barLen-1,4-1,barLen+2,barThickness+2,0)
		DrawBox(w-8-barLen,4,barLen,barThickness,1)
		DrawBox(w-8-barLen,4,barpercent,barThickness,14)
		local scor = "" .. team2Score .. "/15"
		LbDraw_Text(math.floor(w -8 - (barLen/2) - (string_width(tostring(scor))/2)),4+2,tostring(scor),0)
		
		--kills/deaths
		if #deaths > 0 then
			PopSetFont(3)
			local mask = 18
			local maxShow = 12 if #deaths < maxShow then maxShow = #deaths end
			for i = 1,maxShow do
				local str1 = "" .. deaths[i][1]
				local str2 = "" .. deaths[i][2]
				local SstrLen = math.floor(string_width(str1)+string_width(str2))
				local StotalLen = SstrLen + 2 + 2 + 12 + mask + mask + 1 + 1
				local Sstart = math.floor(w-8-StotalLen)
				LbDraw_ScaledSprite(Sstart,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][3]),mask,mask)
				LbDraw_Text(Sstart+1+mask,math.floor(barThickness+24+(i*18)),deaths[i][1],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2,math.floor(barThickness+2+24+(i*18)),get_sprite(0,59),12,12)
				LbDraw_Text(Sstart+1+mask+string_width(str1)+2+2+12,math.floor(barThickness+24+(i*18)),deaths[i][2],0)
				LbDraw_ScaledSprite(Sstart+1+mask+string_width(str1)+2+2+12+string_width(str2)+1,math.floor(barThickness+24+(i*18)),get_sprite(0,deaths[i][4]),mask,mask)
			end
		end
		
		if win == 0 then
			--timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(timer/12)))))/2),32,tostring(TurnsToClock(math.floor(timer/12))),0)
			--tab to read rules
			PopSetFont(11)
			local tab = "Press TAB to read rules"
			DrawBox(1,1,4+string_width(tostring(tab)),4+10,0)
			DrawBox(3,3,string_width(tostring(tab)),10,1)
			LbDraw_Text(3,3,tostring(tab),0)
		elseif win == -1 then
			--RULES timer countdown
			PopSetFont(9)
			LbDraw_Text(math.floor(middle2-(string_width(tostring(TurnsToClock(math.floor(exptimer/12)))))/2),32,tostring(TurnsToClock(math.floor(exptimer/12))),0)
			local txt1 = "The game will start soon"
			local txt2 = "Players can pause and press TAB"
			local txt3 = "to read the rules beforehand"
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),32*2,tostring(txt1),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),32*3,tostring(txt2),0)
			LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),32*4,tostring(txt3),0)
			--host msg about add or low timer spells
			if _gnsi.PlayerNum == 0 then
				local txt1 = "You (host) can cast one of the 2 spells"
				local txt2 = "to increase or decrease the minigame timer"
				local txt3 = "you have until the 10 seconds end"
				PopSetFont(3)
				local txt4 = "current game time: " .. addedTimer .. " minutes."
				PopSetFont(9)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt1))/2),math.floor(h-(32*5)),tostring(txt1),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt2))/2),math.floor(h-(32*4)),tostring(txt2),0)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt3))/2),math.floor(h-(32*3)),tostring(txt3),0)
				PopSetFont(1)
				LbDraw_Text(math.floor(middle2-string_width(tostring(txt4))/2),math.floor(h-(32*2)),tostring(txt4),0)
			end
		end
	end	
end


--Rules TAB
import(Module_Helpers)
local g_DrawMenu = false
function OnKeyDown(key)
    if (key == LB_KEY_TAB) then
        g_DrawMenu = not g_DrawMenu
    end
end
function OnImGuiFrame()
    if (g_DrawMenu) then
		imgui.Begin('Rules:', nil, ImGuiWindowFlags_AlwaysAutoResize)
		
		imgui.TextUnformatted("Grave Diggers MiniGame:")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
		imgui.NextColumn()
		imgui.TextUnformatted("Teams fight in a shapeshifting arena, until only one team remains and wins the round")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Once a round ends, a team wins 1 point for every living shaman (meaning max 4 points per round)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("(in case of a tie, both teams win 1 point)")
	   	imgui.NextColumn()
		imgui.TextUnformatted("The spell \"dig\" is infinite: it lowers the land by a fair amount, while the spell \"soil\" rises it a bit")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Shamans must seek the high ground while sinking the others - ground zero or water means death")
		imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("First team to reach the points objective is victorious!")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Or the game ends after 8 minutes (whoever has most points wins).")
	   	imgui.NextColumn()
		imgui.TextUnformatted("")
	   	imgui.NextColumn()
		imgui.TextUnformatted("Hotkeys:")
		imgui.NextColumn()
		imgui.TextUnformatted("DIG - swarm")
		imgui.NextColumn()
		imgui.TextUnformatted("SOIL - firestorm")
		imgui.NextColumn()
		
		imgui.End()
	end
end

function OnSoundEvent(t_thing, event, flags) 
	if (event == SND_EVENT_INFO_DROP) or (event == SND_EVENT_INFO_BOUNCE) or event == SND_EVENT_SHAM_FSTORM or event == SND_EVENT_ESHAM_FSTORM or event == SND_EVENT_SHAM_INSECT or event == SND_EVENT_ESHAM_INSECT then
		return 1
	end
end

--legendary tree productions ; a tom hanks game
db = createThing(T_EFFECT,M_EFFECT_FLY_THINGUMMY,8,coord_to_c3d(0,54),false,false)
db.u.Effect.Duration = -1 --db.Pos.D3.Ypos = 1024
centre_coord3d_on_block(db.Pos.D3)
set_thing_draw_info(db,TDI_SPRITE_F1_D1, 2122)